// -*- C++ -*-
/*!
 * @file  DFIT_Cal.h for PW
 * @date  $Date$
 *
 * $Id$
 */

#ifndef _DFIT_CAL_H
#define _DFIT_CAL_H

#include <process.h>
#include <windows.h>
#include <fstream>
#include <iostream>
#include <cmath>
#include <String>
#include <math.h>
#include <atltime.h>

#include "ipxdef.h"
#include "ipxsys.h"
#include "ipxprot.h"
#pragma comment(lib,"ipxcmdv.lib")
using namespace std;

#define	XMAG	1
#define	YMAG	1	//Ԉ
#define	X_TEMP_SIZE	60
#define	Y_TEMP_SIZE	60	//ev[gTCY
#define	X_SEARCH_SIZE	640	//{͈
#define	Y_SEARCH_SIZE	100
#define	XSIZE 640
#define	YSIZE 480//J摜TCY

typedef struct{
	int R;
	int L;
}LR;

typedef struct{
	char R;
	char L;
}cLR;

typedef struct{
	double	x;
	double	y;
	double	theta;
} st_pos;

typedef struct{
	LR	x;
	LR	y;
	float v;
	LR	Img[3];
	LR	ImgB[3];
	LR	Src;
	LR	Sft;
	LR	Dst;
	LR	Bin;
	LR	Tempo;
	LR	ret;
	cLR	pixel;
	float	Threshold;
	st_pos	pos;
	std::ofstream TPMlog;
	std::string FileName;
	int CAMERA_DIS;
	double MPPR;
	double MPPL;
} TMdata;


class DFIT_Cal
{
  private:
  // <rtc-template block="private_attribute">
    int ret;
    TMdata tm_data;
	unsigned int id_tpm, id_odm;
	HANDLE m_TPMthread, m_Odmetry, wait_TMP;
    IPErrorTbl Tbl;
    IPCorrControl cnt;
	time_t SystemTime;
	double st_sec;
	LARGE_INTEGER st_freq, st_time, st_init;

  // </rtc-template>

  // <rtc-template block="private_operation">
  // </rtc-template>

  protected:
  // <rtc-template block="protected_attribute">
  // </rtc-template>

  // <rtc-template block="protected_operation">
  // </rtc-template>

  public:
    DFIT_Cal();
    virtual ~DFIT_Cal();
  // <rtc-template block="public_attribute">
  // </rtc-template>

  // <rtc-template block="public_operation">
    int CheckError(int ret);
    void TPmatching();
    void GetPosition(double &px, double &py, double &ptheta, double &timestamp);
    void ResetPosition(void);
    void Stop(void);
	int	Check(int ret);
	void Odmetry();
	void Configuration(std::string m_FileName, int m_CAMERA_DIS, double m_MPPR, double m_MPPL);
	static unsigned __stdcall TPMthread(void*);
	static unsigned __stdcall ODMthread(void*);
  // </rtc-template>
};


#endif // DFIT_CAL_H
